<?php
/*====================================================================================
Plugin Name: Yet Another WebClap for WordPress
Plugin URI: about:_blank
Description: WordPress に web拍手を組み込んでみた。1.新規ページにショートコード[webclap]でページがweb拍手フォームに。2.ウィジェットweb拍手をサイドバーに追加し、web拍手フォームのurlをリンク先に記述。3.解析画面はダッシュボード>yaWeb拍手から。
Author: __trial
Version: 0.1.1
Author URI: http://trial-run.net/
====================================================================================*/


function webclap_button($url, $text, $image) {
	if ($text==null) $text = 'web拍手';
	if ($image==null) $image = '';
	if ($url==null) $url = '';
	if ( $image!='' && $size = getImageSize($image) ) {
		echo '<a href="'.$url.'"><img src="'.$image.'" '.$size[3].' alt="'.$text.'"></a>';
	} else {
		echo '<a href="'.$url.'">'.$text.'</a>';
	}
}
function webclap_button_sc($atts) {
	extract( shortcode_atts( array(
		'text' => 'web拍手',
		'image' => '',
		'url' => '',
	), $atts ) );
	webclap_button($url, $text, $image);
}
add_shortcode('webclap_button', 'webclap_button_sc');

function webclap_LogTable() {
	global $table_prefix;
	return $table_prefix."Webclap";
}
function webclap_CommentTable() {
	global $table_prefix;
	return $table_prefix."Webclap_Comments";
}
$my_plugin_url = WP_PLUGIN_URL . '/' . plugin_basename(dirname(__FILE__));

function get_wchitstoday() {
	global $wpdb;
	$today = date_i18n("Y-m-d");
	$sql = "SELECT COUNT(1) FROM " . webclap_logTable() . " WHERE timestamp >= '{$today}'";
	return $wpdb->get_var($sql);
}
function get_wchitsyesterday() {
	global $wpdb;
	$today = date_i18n("Y-m-d");
	$yesterday = date_i18n("Y-m-d", date_i18n("U")-86400);
	$sql = "SELECT COUNT(1) FROM " . webclap_logTable() . " WHERE timestamp >= '$yesterday' AND timestamp < '$today'";
	return $wpdb->get_var($sql);
}
function get_wchits7days() {
	global $wpdb;
	$sevendaysago = date_i18n("Y-m-d", date_i18n("U")-86400*7);
	$sql = "SELECT COUNT(1) FROM " . webclap_logTable() . " WHERE timestamp >= '{$sevendaysago}'";
	return $wpdb->get_var($sql);
}
function get_wchitsmonth() {
	global $wpdb;
	$month = date_i18n("Y-m-1");
	$sql = "SELECT COUNT(1) FROM " . webclap_logTable() . " WHERE timestamp >= '{$month}'";
	return $wpdb->get_var($sql);
}
function get_wchitstotal() {
	global $wpdb;
	$sql = 'SELECT COUNT(1) FROM ' . webclap_logTable();
	return $wpdb->get_var($sql);
}
function get_wchourlystats_today() {
	global $wpdb;
	$today = date_i18n("Y-m-d");
	$sql = "SELECT
			HOUR(timestamp) AS label,
			HOUR(timestamp) AS label2,
			COUNT(1) AS amount
			FROM " . webclap_logTable();
	$sql .= " WHERE timestamp >= '{$today}' GROUP BY label";
	return $wpdb->get_results($sql);
}
function get_wchourlystats($diff) {
	global $wpdb;
	$head = date_i18n("Y-m-d", date_i18n("U")-86400*($diff-1));
	$tail = date_i18n("Y-m-d", date_i18n("U")-86400*$diff);
	$sql = "SELECT
			HOUR(timestamp) AS label,
			HOUR(timestamp) AS label2,
			COUNT(1) AS amount
			FROM " . webclap_logTable();
	$sql .= " WHERE timestamp >= '$tail' AND timestamp < '$head' GROUP BY label";
	return $wpdb->get_results($sql);
}
function get_wcdailystats($diff) {
	global $wpdb;
	$head = date_i18n("Y-m-01",strtotime("-".($diff-1)." month"));
	$tail = date_i18n("Y-m-01",strtotime("-".$diff." month"));
	$sql = "SELECT
			DAYOFMONTH(timestamp) AS label,
			DAYOFMONTH(timestamp) AS label2,
			COUNT(1) AS amount
			FROM " . webclap_logTable();
	$sql .= " WHERE timestamp >= '$tail' AND timestamp < '$head' GROUP BY label";
	return $wpdb->get_results($sql);
}

function my_activation(){
	global $wpdb;
	if ($wpdb->get_var("show tables like '".webclap_LogTable()."'") != webclap_LogTable()) {
		$sql = "CREATE TABLE " . webclap_LogTable() . " (
			id INTEGER NOT NULL AUTO_INCREMENT,
			IP VARCHAR(16) NOT NULL,
			timestamp DATETIME NOT NULL,
			UNIQUE KEY id (id)
		);";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
	}
	if ($wpdb->get_var("show tables like '".webclap_CommentTable()."'") != webclap_CommentTable()) {
		$sql = "CREATE TABLE " . webclap_CommentTable() . " (
			id INTEGER NOT NULL AUTO_INCREMENT,
			IP VARCHAR(16) NOT NULL,
			timestamp DATETIME NOT NULL,
			content TEXT NOT NULL,
			UNIQUE KEY id (id)
		);";
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
	}
}

register_activation_hook(__FILE__, 'my_activation');

add_action('admin_menu', 'my_plugin_menu');
function my_plugin_menu() {
	add_submenu_page('index.php', 'yaWeb拍手 設定とか', 'yaWeb拍手', 1, 'yawebclap/yawebclap.php', 'my_plugin_options');
}
function my_plugin_options() {
	global $wpdb;
	
	$sql = "SELECT * FROM " . webclap_CommentTable() . " ORDER BY timestamp DESC";
	$comments = $wpdb->get_results($sql);
	$url = str_replace( '%7E', '~', $_SERVER['REQUEST_URI']);
	$pos = strpos($url,'&');
	if ($pos!='') $url = substr($url,0,strpos($url,'&'));
	$date_pos = 1;
	$month_pos = 0;
	$comments_pos = 0;
	if (isset($_GET['date'])) {
		$date = $_GET['date'];
		$date = strtotime(substr($date,0,2) . '-' . substr($date,2,2) . '-' . substr($date,4));
		$date_pos = (int)( ( date_i18n("U") - $date ) / (3600*24) );
	}
	if (isset($_GET['month'])) {
		$month = $_GET['month'];
		$month_pos = ( substr(date_i18n('ym'),0,2) - substr($month,0,2) )*12 + substr(date_i18n('ym'),2) - substr($month,2);
	}
	if (isset($_GET['comment'])) {
		$comments_pos = $_GET['comment'];
	}
	
	$td_style = 'border:1px solid #AAA; padding: 1px 4px;';
	echo '<div>';
	
	echo '<h3>web拍手 解析結果</h3>
		<table><tr><td style="'.$td_style.'width: 8em;background-color:#EEE;">拍手数の合計</td>
		<td style="'.$td_style.'width: 8em;background-color:#EEE;">今日の拍手数</td>
		<td style="'.$td_style.'width: 8em;background-color:#EEE;">昨日の拍手数</td>
		<td style="'.$td_style.'width: 8em;background-color:#EEE;">過去7日間</td>
		<td style="'.$td_style.'width: 8em;background-color:#EEE;">今月の拍手数</td></tr>';
	echo '<tr><td style="'.$td_style.'">'.get_wchitstotal().'</td>
		<td style="'.$td_style.'">'.get_wchitstoday().'</td>
		<td style="'.$td_style.'">'.get_wchitsyesterday().'</td>
		<td style="'.$td_style.'">'.get_wchits7days().'</td>
		<td style="'.$td_style.'">'.get_wchitsmonth().'</td></tr></table>';
	
	echo '<h3>今日の拍手履歴</h3>';
	renderstats(get_wchourlystats_today(), 24);
	
	echo '<h3>' . ($date_pos==1?'昨日':ltrim(date_i18n('m',$date),'0').'月'.ltrim(date_i18n('d',$date),'0').'日') . 'の拍手履歴</h3>';
	echo '<div style="font-size:10px;padding-left:40px;">';
	for($i=1; $i<=14; $i++) {
		$date = date_i18n("ymd",date_i18n("U")-86400*$i);
		if ($i==$date_pos) {
			echo '<span style="margin:0 4px;">' . ltrim(substr($date,2,2),'0') . '月' . ltrim(substr($date,4),'0') . '日</span>';
		} else {
			echo '<span style="margin:0 4px;"><a href="' . $url . '&date=' . $date . '">' . ltrim(substr($date,2,2),'0') . '月' . ltrim(substr($date,4),'0') . '日</a></span>';
		}
	}
	echo '</div>';
	renderstats(get_wchourlystats($date_pos), 24);
	
	echo '<h3>' . ($month_pos==0?'今月':ltrim(substr($month,0,2),'0').'年'.ltrim(substr($month,2),'0').'月') . 'の拍手履歴</h3>';
	echo '<div style="font-size:10px;padding-left:40px;">';
	for($i=0; $i<12; $i++) {
		$date = date_i18n("ym",strtotime("-".$i." month"));
		if ($i==$month_pos) {
			echo '<span style="margin:0 4px;">' . substr($date,0,2) . '年' . ltrim(substr($date,2),'0') . '月</span>';
		} else {
			echo '<span style="margin:0 4px;"><a href="' . $url . '&month=' . $date . '">' . substr($date,0,2) . '年' . ltrim(substr($date,2),'0') . '月</a></span>';
		}
	}
	echo '</div>';
	renderstats(get_wcdailystats($month_pos), date_i18n('d',strtotime(date_i18n('y-m-01',strtotime("-".($month_pos-1)." month")))-3600));
	
	$comments_disp = 20;
	$comments_start_pos = nrange( 0, $comments_pos-9, (int)(count($comments)/$comments_disp-20) );
	echo '<h3>拍手コメント ログ<a name="comlog">&nbsp;</a></h3>';
	// << ... [21] [22] [23] [24] [25] [26] ... >>
	echo '<div style="padding-left:40px;">';
	if ( $comments_start_pos!=0 ) {
		echo '<span style="margin:0 4px;">' . '<a href="' . $url . '&comment=' . 0 . '">&lt;&lt;</a>' .'</span><span style="margin:0 4px;">...</span>';
	}
	for( $i=$comments_start_pos; $i<count($comments)/$comments_disp&&$i<$comments_start_pos+20; $i++) {
		if ($i==$comments_pos) {
			echo '<span style="margin:0 4px;">[' . $i . ']</span>';
		} else {
			echo '<span style="margin:0 4px;"><a href="' . $url . '&comment=' . $i . '#comlog">[' . $i . ']</a></span>';
		}
	}
	if ( $i<count($comments)/$comments_disp ) {
		echo '<span style="margin:0 4px;">...</span><span style="margin:0 4px;">' . '<a href="' . $url . '&comment=' . (int)(count($comments)/$comments_disp-1) . '">&gt;&gt;</a>' .'</span>';
	}
	echo '</div>';
	echo '<table><tr><td style="'.$td_style.'width: 3em;background-color:#EEE;">No.</td>
			<td style="'.$td_style.'width: 10em;background-color:#EEE;">IPアドレス</td>
			<td style="'.$td_style.'width: 8em;background-color:#EEE;">日時</td>
			<td style="'.$td_style.'width: 48em;background-color:#EEE;">コメント</td></tr>';
	for($i=$comments_disp*$comments_pos; $i<count($comments)&&$i<$comments_disp*($comments_pos+1); $i++) {
		echo '<tr><td style="'.$td_style.'">' . ($i+1) . '</td>
			<td style="'.$td_style.'">' . $comments[$i]->IP. '</td>
			<td style="'.$td_style.'">' . date_i18n('m.d H:i', strtotime($comments[$i]->timestamp)). '</td>
			<td style="'.$td_style.'">' . $comments[$i]->content. '</td></tr>';
	}
	echo '</table>';
	
	if(0) {
		$sql = "SELECT * FROM " . webclap_LogTable() . " ORDER BY timestamp DESC";
		$results = $wpdb->get_results($sql);
		echo '<h3>web拍手 ログ</h2>
			<table><tr><td style="'.$td_style.'width: 10em;background-color:#EEE;">IPアドレス</td>
			<td style="'.$td_style.'width: 8em;background-color:#EEE;">日時</td></tr>';
		for($i=0; $i<count($results)&&$i<50; $i++) {
			echo '<tr><td style="'.$td_style.'">' .$results[$i]->IP. '</td>
			<td style="'.$td_style.'">' . date_i18n('y.m.d H:i', strtotime($results[$i]->timestamp)). '</td></tr>';
		}
		echo '</table>';
	}
	echo '</div>';
}

function renderstats($rows, $size) {
	$td_style = 'border:1px solid #AAA; padding: 1px 4px;text-align:center;width:20px;';
	$url = WP_PLUGIN_URL . '/' . plugin_basename(dirname(__FILE__));
	$pos = 0;
	$max = 0;
	for ( $i=0;$i<count($rows);$i++ ) {
		if ( $max<$rows[$i]->amount ) {
			$max = $rows[$i]->amount;
		}
	}
	echo '<table><tr>';
	for (($size==24?$i=0:$i=1); ($size==24?$i<$size:$i<=$size);$i++) {
		if ($rows[$pos]->label==$i && count($rows)!=0) {
			echo '<td style="'.$td_style.'height:110px;vertical-align:bottom;color:#666;font-size:10px">'
					. ($rows[$pos]->amount) . '<br />
					<img src="'.$url.'/graph.png" width="8px" height="'. (int)(80*$rows[$pos]->amount/$max) .'" alt="plot" />
				</td>';
			$pos++;
		} else {
			echo '<td style="'.$td_style.'height:110px;vertical-align:bottom;color:#CCC;">0</td>';
		}
	}
	echo '<tr>';
	for ($i=0;$i<$size;$i++) {
		echo '<td style="'.$td_style.'color:#444;font-size:10px;padding:1px 2px;background-color:#EEE;">' . ($size==24?$i.'時':($i+1).'日') . '</td>';
	}
	echo '</tr></table>';
}
function nrange( $low, $num, $high) {
	if ( $high<$low ) $high = $low;
	return $num>$high ? $high : ( $num<$low ? $low : $num) ;
}

function webclap_add() {
	global $wpdb;
	$timestamp = gmdate("Y-m-d H:i:s", time() + ( get_option('gmt_offset') * 60 * 60 ));
	$remoteaddr = 'unknown';
	if ($_SERVER['REMOTE_ADDR']) {
		$remoteaddr = $_SERVER['REMOTE_ADDR'];
	}
	$sql = "INSERT INTO " . webclap_LogTable();
	$sql .= " (IP, timestamp) VALUES (";
	$sql .= "'" . $wpdb->escape( $remoteaddr ) . "',";
	$sql .= "'" . $timestamp . "')";
	$results = $wpdb->query($sql);
	$text = htmlspecialchars($_POST["message"]);
	if ($text!="") {
		$sql = "INSERT INTO " . webclap_CommentTable();
		$sql .= " (IP, timestamp, content) VALUES (";
		$sql .= "'" . $wpdb->escape($remoteaddr) . "',";
		$sql .= "'" . $timestamp . "',";
		$sql .= "'" . $text . "')";
		$results = $wpdb->query($sql);
	}
}

function webclap_form($atts) {
	$count = $_POST["count"];
	if ($count=='') {
		$count = 0;
	}
	if ($count<9) {
		$html = '<!-- コメントフォーム -->';
		$html.= '<form action="" method="POST">';
		$html.= '<input type="submit" value="もっと送る" id="webclap-submit"><br />';
		$html.= '<input type="hidden" name="count" value="'.($count+1).'"><br />';
		$html.= '<textarea name="message" rows="3" cols="50" value="" id="webclap-textarea"></textarea>';
		$html.= '</form>';
		$html.= '<!-- コメントフォーム -->';
		webclap_add();
	} else {
		$html = '<p>たくさんの拍手ありがとうございました。</p>';
	}
	return $html;
}
add_shortcode('webclap', 'webclap_form');

class webclap_widget extends WP_Widget {
	function webclap_widget() {
		$widget_ops = array('web拍手を設置するウィジェットです');
 		parent::WP_Widget(false,$name='web拍手',$widget_ops);
	}
	
	function form( $instance ) {
		$title = esc_attr( $instance['title'] );
		$url = esc_attr( $instance['url'] );
		$image = esc_attr( $instance['image'] );
		$text = esc_attr( $instance['text'] );
		?>
		<!--Form-->
		<p>
		<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('タイトル:'); ?>
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
		</label>
		<label for="<?php echo $this->get_field_id('url'); ?>"><?php _e('リンク先（url）:'); ?>
			<input class="widefat" id="<?php echo $this->get_field_id('url'); ?>" name="<?php echo $this->get_field_name('url'); ?>" type="text" value="<?php echo $url; ?>" />
		</label>
		<label for="<?php echo $this->get_field_id('image'); ?>"><?php _e('画像（url）:'); ?>
			<input class="widefat" id="<?php echo $this->get_field_id('image'); ?>" name="<?php echo $this->get_field_name('image'); ?>" type="text" value="<?php echo $image; ?>" />
		</label>
		<label for="<?php echo $this->get_field_id('text'); ?>"><?php _e('テキスト:'); ?>
			<input class="widefat" id="<?php echo $this->get_field_id('text'); ?>" name="<?php echo $this->get_field_name('text'); ?>" type="text" value="<?php echo $text; ?>" />
		</label>
		</p>
		<!--/Form-->
		<?php
	}
	function widget( $args, $instance ) {
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		$url = apply_filters( 'widget_title', $instance['url'] );
		$image = apply_filters( 'widget_title', $instance['image'] );
		$text = apply_filters( 'widget_title', $instance['text'] );
		
		
		if ($title=='') $title = 'web拍手';
		if ($text=='') $text = 'web拍手';
		
		echo $before_widget;
		echo $before_title . $title . $after_title;
		if ( $image!='' && $size = getImageSize($image) ) {
			echo '<a href="'.$url.'"><img src="'.$image.'" '.$size[3].' alt="'.$text.'"></a>';
		} else {
			echo '<a href="'.$url.'">'.$text.'</a>';
		}
		echo $after_widget;
	}
	function update( $new_instance, $old_instance ) {
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['url'] = strip_tags($new_instance['url']);
		$instance['image'] = strip_tags($new_instance['image']);
		$instance['text'] = strip_tags($new_instance['text']);
		return $instance;
	}
}
function webclap_widgetInit() {
	register_widget('webclap_widget');
}
add_action('widgets_init', 'webclap_widgetInit');

?>
